// Vehicle_Tudor.cs

datablock TSShapeConstructor(TudorDts)
{
	baseShape  = "./tudorv5.dts";
	sequence0  = "./root.dsq root";
	sequence1  = "./bootlidopen.dsq bootlidopen";
	sequence2  = "./bootlidclose.dsq bootlidclose";
	sequence3  = "./bonnetlidopen.dsq bonnetlidopen";
	sequence4  = "./bonnetlidclose.dsq bonnetlidclose";
	sequence5  = "./ldopen.dsq ldopen";
	sequence6  = "./ldclose.dsq ldclose";
	sequence7  = "./rdopen.dsq rdopen";
	sequence8  = "./rdclose.dsq rdclose";
};  

datablock WheeledVehicleData(TudorVehicle)
{
	category = "Vehicles";
	displayName = " ";
	shapeFile = "./tudorv5.dts";
	emap = true;
	minMountDist = 3;
	
	numMountPoints = 4;
	mountThread[0] = "sit";
	mountThread[1] = "sit";
	mountThread[2] = "sit";
	mountThread[3] = "sit";

	maxDamage = 200.00;
	destroyedLevel = 200.00;
	energyPerDamagePoint = 160;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier = 0.02;

	massCenter = "0 0.26 0.05";
	//massBox = "2 5 1";

	maxSteeringAngle = 0.9785; // Maximum steering angle, should match animation
	integration = 4; // Force integration time: TickSec/Rate
	tireEmitter = VehicleTireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false; // Roll the camera with the vehicle
	cameraMaxDist = 13; // Far distance from vehicle
	cameraOffset = 7.5; // Vertical offset from camera mount point
	cameraLag = 0.0; // Velocity lag of camera
	cameraDecay = 0.75; // Decay per sec. rate of velocity lag
	cameraTilt = 0.4;
	collisionTol = 0.1; // Collision distance tolerance
	contactTol = 0.1;

	useEyePoint = false;	

	defaultTire = TudorTire;
	defaultSpring = TudorSpring;
	//flatTire = jeepFlatTire;
	//flatSpring = jeepFlatSpring;

	numWheels = 4;

	// Rigid Body
	mass = 300;
	density = 5.0;
	drag = 1.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10; // Impacts over this invoke the script callback
	softImpactSpeed = 10; // Play SoftImpact Sound
	hardImpactSpeed = 15; // Play HardImpact Sound
	groundImpactMinSpeed = 10.0;

	// Engine
	engineTorque = 10000; // Engine power
	engineBrake = 2000; // Braking when throttle is 0
	brakeTorque = 4000; // When brakes are applied
	maxWheelSpeed = 33; // Engine scale by current speed / max speed

	rollForce = 900;
	yawForce = 600;
	pitchForce = 1000;
	rotationalDrag = 0.2;

	// Advanced Steering
	steeringAutoReturn = true;
	steeringAutoReturnRate = 0.9;
	steeringAutoReturnMaxSpeed = 10;
	steeringUseStrafeSteering = true;
	steeringStrafeSteeringRate = 0.1;

	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;	
	hardSplashSoundVelocity = 20.0;	
	exitSplashSoundVelocity = 5.0;
		
	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";
	
	// Sounds
	//jetSound = ScoutThrustSound;
	//engineSound = idleSound;
	//squealSound = skidSound;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	//wheelImpactSound = slowImpactSound;

	//explosion = VehicleExplosion;
	justcollided = 0;

	uiName = "Tudor ";
	rideable = true;
	lookUpLimit = 0.65;
	lookDownLimit = 0.45;

	paintable = true;
	
	damageEmitter[0] = VehicleBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;

	damageEmitter[1] = VehicleBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;

	numDmgEmitterAreas = 1;

	initialExplosionProjectile = TudorExplosionProjectile;
	initialExplosionOffset = 0; //offset only uses a z value for now

	burnTime = 4000;

	finalExplosionProjectile = TudorFinalExplosionProjectile;
	finalExplosionOffset = 0.5; //offset only uses a z value for now

	minRunOverSpeed = 4; //how fast you need to be going to run someone over (do damage)
	runOverDamageScale = 8; //when you run over someone, speed * runoverdamagescale = damage amt
	runOverPushScale = 1.2; //how hard a person you're running over gets pushed

	//protection for passengers
	protectPassengersBurn = false; //protect passengers from the burning effect of explosions?
	protectPassengersRadius = true; //protect passengers from radius damage (explosions) ?
	protectPassengersDirect = false; //protect passengers from direct damage (bullets) ?

	isInteractive = true;
	iNumZones = 4;
	iZone[0] = "-1.4 1.7 1.05 1.4 5 5";
	iZoneScript[0] = "onHood";
	iZone[1] = "-1.4 -5 0.7 1.4 -2.55 1.5";
	iZoneScript[1] = "onTrunk";
	iZone[2] = "-5 -0.5 0.2 -1.4 1.2 2.5";
	iZoneScript[2] = "onLeftDoor";
	iZone[3] = "1.4 -0.5 0.2 5 1.2 2.5";
	iZoneScript[3] = "onRightDoor";
};

function TudorVehicle::onAdd(%this,%obj)
{
	parent::onadd(%this,%obj);
	%obj.setWheelTire(0, TudorTire);
	%obj.setWheelTire(1, TudorTire);
	%obj.setWheelTire(2, TudorTire);
	%obj.setWheelTire(3, TudorTire);

	%obj.setWheelSpring(0, Tudorspring);
	%obj.setWheelSpring(1, Tudorspring);
	%obj.setWheelSpring(2, Tudorspring);
	%obj.setWheelSpring(3, Tudorspring);

	%obj.setWheelSteering(0,1);
	%obj.setWheelSteering(1,1);
	%obj.setWheelSteering(2,0);
	%obj.setWheelSteering(3,0);

	%obj.mountable = true;
	%obj.playthread(0, root);

}
function TudorVehicle::onHood(%this, %obj, %client, %offset, %position, %vector)
{
	%time = getSimTime();
	if((%time - %obj.hoodTime) > 900)
	{
		%obj.hoodTime = %time;
		%obj.hood = !%obj.hood;
		%obj.playThread(0, %obj.hood ? bonnetlidopen : bonnetlidclose);
	}
	return 1;
}
function TudorVehicle::onTrunk(%this, %obj, %client, %offset, %position, %vector)
{
	%time = getSimTime();
	if((%time - %obj.trunkTime) > 900)
	{
		%obj.trunkTime = %time;
		%obj.trunk = !%obj.trunk;
		%obj.playThread(1, %obj.trunk ? bootlidopen : bootlidclose);
	}
	return 1;
}
function TudorVehicle::onLeftDoor(%this, %obj, %client, %offset, %position, %vector)
{
	%time = getSimTime();
	if((%time - %obj.leftDoorTime) > 900)
	{
		%obj.leftDoorTime = %time;
		%obj.leftDoor = !%obj.leftDoor;
		%obj.playThread(2, %obj.leftDoor ? ldopen : ldclose);
	}
	return 1;
}
function TudorVehicle::onRightDoor(%this, %obj, %client, %offset, %position, %vector)
{
	%time = getSimTime();
	if((%time - %obj.rightDoorTime) > 900)
	{
		%obj.rightDoorTime = %time;
		%obj.rightDoor = !%obj.rightDoor;
		%obj.playThread(3, %obj.rightDoor ? rdopen : rdclose);
	}
	return 1;
}
